﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore	
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "Planner"  '<-------------------------------------------------------- IMPORTANT
	' will hold the unique browsers window id
	Private ABMPageId As String = ""
	' your own variables	
	Private ActiveDay As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!
	BuildPage		
End Sub

#Region ABM
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)	
'''	Log("Connected")
'''		
'''	ws = WebSocket1		
'''	
'''	ABMPageId = ABM.GetPageID(page, Name,ws)
'''	
'''	Dim session As HttpSession = ABM.GetSession(ws, Main.Server.SessionMaxInactiveIntervalSeconds)
'''	If session.IsNew Then
'''		session.Invalidate
'''		Main.Server.NavigateToPage(ws, "", "./")
'''		Return
'''	End If
'''		
'''	If Main.Server.NeedsAuthorization Then
'''		If session.GetAttribute2("IsAuthorized", "") = "" Then
'''			Main.Server.NavigateToPage(ws, ABMPageId, "../")
'''			Return
'''		End If
'''	End If		
'''	ABM.UpdateFromCache(Me, Main.Server.CachedPages, ABMPageId, ws)		
'''	If page.ComesFromPageCache Then
'''    	' when we have a page that is cached it doesn't matter if it comes or not from a new connection we serve the cached version.
'''		Log("Comes from cache")		
'''    	page.Refresh		
'''    	page.FinishedLoading		
'''	Else
'''    	If page.WebsocketReconnected Then
'''			Log("Websocket reconnected")
'''        	' when we have a client that doesn't have the page in cache and it's websocket reconnected and also it's session is new - basically when the client had internet problems and it's session (and also cache) expired before he reconnected so the user has content in the browser but we don't have any on the server. So we need to reload the page.
'''        	' when a client that doesn't have the page in cache and it's websocket reconnected but it's session is not new - when the client had internet problems and when he reconnected it's session was valid but he had no cache for this page we need to reload the page as the user browser has content, reconnected but we have no content in cache
'''        	Main.Server.NavigateToPage (ws, ABMPageId, "./" & page.PageHTMLName)
'''    	Else
'''        	' when the client did not reconnected it doesn't matter if the session was new or not because this is the websockets first connection so no dynamic content in the browser ... we are going to serve the dynamic content...
'''        	Log("Websocket first connection")
'''			page.Prepare
'''			ConnectPage			
'''    	End If
'''	End If
	'''	Log(ABMPageId)
	Log("Connected")
	ws = WebSocket1
	ABMPageId = ABM.GetPageID(page, Name,ws)
	
	Main.Server.Connected(Me, ws, page, ABMPageId)
	
	Log("abmpageid: " & ABMPageId)
End Sub

Private Sub WebSocket_Disconnected
	Log("Disconnected")
	Main.Server.Disconnected(ws)
End Sub

Sub Page_ParseEvent(Params As Map)
	Dim eventName As String = Params.Get("eventname")
'''	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
'''	
	Log("eventName: " & eventName)
'''	
'''	If eventName = "beforeunload" Then
'''		Log("preparing for url refresh")
'''		ABM.RemoveMeFromCache(Main.Server.CachedPages, ABMPageId)
'''		Return
'''	End If
'''	Dim caller As Object = page.GetEventHandler(Me, eventName)
'''	If caller = Me Then
'''		If SubExists(Me, eventName) Then
'''			Params.Remove("eventname")
'''			Params.Remove("eventparams")
'''			If eventName = "page_dropped" Then
'''				page.ProcessDroppedEvent(Params)
'''			End If
'''			Select Case Params.Size
'''				Case 0
'''					CallSub(Me, eventName)
'''				Case 1
'''					CallSub2(Me, eventName, Params.Get(eventParams(0)))
'''				Case 2
'''					If Params.get(eventParams(0)) = "abmistable" Then
'''						Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
'''						CallSub2(Me, eventName, PassedTables)
'''					Else
'''						CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
'''					End If
'''				Case Else
'''					' cannot be called directly, to many param
'''					CallSub2(Me, eventName, Params)
'''			End Select
'''		End If
'''	Else
'''		CallSubDelayed2(caller, "ParseEvent", Params) 'ignore
'''	End If
	Main.Server.Page_ParseEvent(Me, page, ABMPageId, Params)
End Sub

public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(Main.Server.MyTheme)

	' add your specific page themes
	
End Sub

public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & Main.Server.AppName & "/" & Name, False, Main.Server.SessionMaxInactiveIntervalSeconds, theme)
	page.ShowLoader=True
	page.PageHTMLName = "index.html"
	page.PageTitle = "Planner"
	page.PageDescription = "Planner example"
	page.PageKeywords = ""
	page.PageSiteMapPriority = ""
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_YEARLY
		
	page.ShowConnectedIndicator = True
				
	' adding a navigation bar
	' ABMShared.BuildNavigationBar(page, "My Page","../images/logo.png", "", "", "")	
	'''Main.BuildNavigationBar(page, "Planner", "../images/logo.png", "", "", "")
			
	' create the page grid
	page.AddRowsM(2,True,20,0, "").AddCells12MP(1,0,0,0,0,"")	
	page.AddRow(1, True, "", "").AddCells12(1, "")

	
	
	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	
	ActiveDay = DateTime.GetDayOfWeek(DateTime.Now)
	
	Dim tabs As ABMTabs
	Dim planner1 As ABMPlanner
	Dim calendar As ABMCalendar
	tabs.Initialize(page, "tabs", "")
	tabs.AddTab("plannerpage", "Planner", BuildTabContainer("planTab"), 3, 3, 3, 12, 12, 12, True, True, "", "")
	planner1.Initialize(page, "plannerpage2", True, 7, 19, 30, False, "")
	planner1.SetActiveDay(ActiveDay)
	DateTime.DateFormat = "yyyy-MM-dd"
	calendar.Initialize(page, "calendar", DateTime.Date(DateTime.Now), ABM.FIRSTDAYOFWEEK_SUNDAY, "en", ABM.CALENDAR_DEFAULTVIEW_MONTH, "")
	tabs.GetTabPage("plannerpage").Cell(1,1).AddComponent(calendar)
	tabs.GetTabPage("plannerpage").Cell(1,1).MarginLeft = "-40px;"
	tabs.GetTabPage("plannerpage").Cell(1,2).AddComponent(planner1)
	tabs.GetTabPage("plannerpage").Cell(1,2).SetFixedHeight(420, False)
	tabs.GetTabPage("plannerpage").Cell(1,2).SetExtraStyle("border: 1px solid red;")
	tabs.GetTabPage("plannerpage").Cell(1,2).MarginTop = "30px;"
	tabs.GetTabPage("plannerpage").Cell(1,2).MarginLeft = "10px;"
	tabs.GetTabPage("plannerpage").Cell(1,2).MarginRight = "0px;"
	page.Cell(1,1).AddComponent(tabs)

End Sub

public Sub ConnectPage()			
	'	connecting the navigation bar
	' ABMShared.ConnectNavigationBar(page)
	
	Main.ConnectNavigationBar(page)
	
	' refresh the page
	page.Refresh
	
	' Tell the browser we finished loading
	page.FinishedLoading
	' restoring the navigation bar position
	page.RestoreNavigationBarPosition	
End Sub
#end region

#Region ABMPage
' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	' saving the navigation bar position
	page.SaveNavigationBarPosition
	If Action = "LogOff" Then
		Main.LogOff(page)
		Return
	End If

	Main.Server.NavigateToPage(ws, ABMPageId, Value)
End Sub

Sub Page_DebugConsole(message As String)
	Log("---> " & message)
End Sub

Sub BuildTabContainer(id As String) As ABMContainer
	Dim Tabc As ABMContainer
	Tabc.Initialize(page, id,"tabpagewhite")
    
	Tabc.AddRows(1,True, "").AddCellsOS(1, 0, 0, 0, 3, 3, 3, "").AddCellsOS(1, 3, 3, 3, 9 ,9, 9, "")
	'''Tabc.AddRows(1, True, "").AddCellsOS(1, 0, 0, 0, 3, 3, 3, "")
	Tabc.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
    
	Return Tabc
End Sub

Sub calendar_DayClicked(date As String)
	Log("date clicked: " & date)
	Dim ticks As Long = DateTime.DateParse(date)
	ActiveDay = DateTime.GetDayOfWeek(ticks)
	
	plannerpage2_ActiveDayChanged(ActiveDay)
	
	Log("new activeday is: " & ActiveDay)

End Sub

Sub plannerpage2_ActiveDayChanged(day As Int)
	Dim tabs As ABMTabs = page.Component("tabs")
	Dim cont As ABMContainer = tabs.GetTabPage("plannerpage")
	Dim planner1 As ABMPlanner = cont.Cell(1,2).Component("plannerpage2")
	planner1.SetActiveDay(day)
	planner1.Refresh
End Sub

Sub plannerpage2_Refreshed()
	page.Resume
End Sub
#end region

